from gurobipy import *                          #import gurobi library

m = Model("101")                                #create model

x_1 = m.addVar(name="x_1",lb=0,ub=GRB.INFINITY) #add variable
x_2 = m.addVar(name="x_2",lb=0,ub=GRB.INFINITY) #add variable
m.update()                                      #render variables accessible

m.addConstr(x_2 - x_1 <= 1)                     #add constraint
m.addConstr(x_1 + 6*x_2 <= 15)                  #add constraint
m.addConstr(4*x_1-x_2 <= 10)                    #add constraint

m.setObjective(x_1 + x_2, sense=GRB.MAXIMIZE)   #set objective function

m.update()                                      #realize model changes
m.optimize()                                    #optimize it!

print "\nGurobi finished computing!\n"

if m.getAttr("Status") == 2:                    #check if (optimal) solution was found
    print "Optimal solution of value {} was computed: x_1 = {} and x_2 = {}".\
        format(m.getAttr("ObjVal"), x_1.X, x_2.X)
else:
    print "No optimal solution was found!"
