#Input

set Students;
set Tutorials;
param current_tutorial{Students} symbolic in Tutorials;
set Wanted_Tutorials{Students} in Tutorials;
param current_load{Tutorials} > 0;
param capacity{Tutorials} > 0;


#Variables

var assignment{Students, Tutorials} binary;


#Constraints

subject to only_assign_to_wanted_tutorials
{studi in Students}:
	sum{tut in Wanted_Tutorials[studi] union {current_tutorial[studi]}} assignment[studi, tut] == 1;

subject to forbid_assignment_to_unwanted_tutorials
{studi in Students}:
	sum{tut in Tutorials diff (Wanted_Tutorials[studi] union {current_tutorial[studi]})} assignment[studi, tut] == 0;

subject to capacity_may_not_be_exceeded
{tut in Tutorials}:
	current_load[tut] + 
	sum{studi in Students}
	(
		if current_tutorial[studi] == tut then
		(
			sum{tut2 in Wanted_Tutorials[studi] diff {tut}}
			(
				- assignment[studi, tut2]
			)		
		)
		else
		(
			assignment[studi, tut]
		)
	)	
	<= capacity[tut];


# Objective

maximize number_of_studis_with_wanted_tutorial:
	sum{studi in Students, tut in Wanted_Tutorials[studi]}  assignment[studi, tut];


solve;

#iterate over all students and all tutorial which are not the current tutorial of the respective student
for {studi in Students, tut in Tutorials:  tut != current_tutorial[studi] }
{   #only print assignments which are set to true, i.e. novel tutorial assignments
    for {foo in {current_tutorial[studi]}: assignment[studi,tut] > 0}
	printf "%s %s\n", studi, tut;
}

end;
